/***
	Copyright (c) 2008 CommonsWare, LLC
	
	Licensed under the Apache License, Version 2.0 (the "License"); you may
	not use this file except in compliance with the License. You may obtain
	a copy of the License at
		http://www.apache.org/licenses/LICENSE-2.0
	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.commonsware.android.menus;

import android.app.Activity;
import android.os.Bundle;
import android.app.ListActivity;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;


public class MenuDemo extends ListActivity {
	TextView selection;
	String[] items={"lorem", "ipsum", "dolor", "sit", "amet",
					"consectetuer", "adipiscing", "elit", "morbi", "vel",
					"ligula", "vitae", "arcu", "aliquet", "mollis",
					"etiam", "vel", "erat", "placerat", "ante",
					"porttitor", "sodales", "pellentesque", "augue", "purus"};
	public static final int EIGHT_ID = Menu.FIRST+1;
	public static final int SIXTEEN_ID = Menu.FIRST+2;
	public static final int TWENTY_FOUR_ID = Menu.FIRST+3;
	public static final int TWO_ID = Menu.FIRST+4;

	@Override
	public void onCreate(Bundle icicle) {
	super.onCreate(icicle);
	setContentView(R.layout.main);
		setListAdapter(new ArrayAdapter<String>(this,
								android.R.layout.simple_list_item_1, items));
		selection=(TextView)findViewById(R.id.selection);
		
		getListView()
			.setOnPopulateContextMenuListener(new View.OnPopulateContextMenuListener() {
			public void onPopulateContextMenu(ContextMenu menu,
																					View v,
																					Object menuInfo) {
				populateMenu(menu);
				menu.setHeader("Divider Height");
			}
		});
	}
	
	public void onListItemClick(ListView parent, View v,
																int position, long id) {
	 	selection.setText(items[position]);
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		populateMenu(menu);

		return(super.onCreateOptionsMenu(menu));
	}

	@Override
	public boolean onOptionsItemSelected(Menu.Item item) {
		applyMenuChoice(item);

		return(applyMenuChoice(item) ||
						super.onOptionsItemSelected(item));
	}

	@Override
	public boolean onContextItemSelected(Menu.Item item) {

		return(applyMenuChoice(item) ||
						super.onContextItemSelected(item));
	}
	
	private void populateMenu(Menu menu) {
		menu.add(0, TWO_ID, "2 Pixels");
		menu.add(0, EIGHT_ID, "8 Pixels");
		menu.add(0, SIXTEEN_ID, "16 Pixels");
		menu.add(0, TWENTY_FOUR_ID, "24 Pixels");
	}
	
	private boolean applyMenuChoice(Menu.Item item) {
		switch (item.getId()) {
			case EIGHT_ID:
				getListView().setDividerHeight(8);
				return(true);
		
			case SIXTEEN_ID:
				getListView().setDividerHeight(16);
				return(true);
		
			case TWENTY_FOUR_ID:
				getListView().setDividerHeight(24);
				return(true);
		
			case TWO_ID:
				getListView().setDividerHeight(2);
				return(true);
		}

		return(false);
	}
}